
; TAREAS.INC: MACROS LIBRARY - BIBLIOTECA DE MACROS

; By nuMIT_or, 1999.
; CONTACT: nuMIT_or@iname.com
; WEB PAGE: http://members.xoom.com/numit_or/asm.html

; =======================================================================

; .COM File header - Encabezado de archivo .COM
headc           macro
                .model small
                .code
                org 100h
                start: jmp main
                endm


; ========================================================================

; Clean the monitor - Limpia el monitor
CLEAN           MACRO
                MOV     AX,0600H
                MOV     BH,07H
                MOV     CX,0000H
                MOV     DX,184FH
                INT     10H

                MOV     AH,02
                MOV     BH,00
                MOV     DX,0000
                INT     10H
                ENDM



; ========================================================================

; Pause process - Detiene el proceso hasta que se pulsa una tecla

pause           macro
                mov     ah,10h
                int     16h
                endm

; ==========================================================================

; Get out to DOS - Salir a DOS
SALIDA          macro
                mov     ax,04c00H
                int     21h
                endm

; =========================================================================

; Prints strings in the monitor. Acepts colors
; Imprime cadenas en el monitor aceptando la inclusin de colores
IMPR    MACRO   x, y
LOCAL   IMP_01
LOCAL   IMP_02
LOCAL   IMP_03
LOCAL   IMP_04
LOCAL   IMP_08
LOCAL   IMP_09
LOCAL   IMP_21,IMP_80,IMP_90
        LEA     SI,x
        MOV     BX,y
        MOV     AH,03H
        INT     10H
        XOR     BP,BP
IMP_01: MOV     AH,02H
        INT     10H
        LODSB
        CMP     AL,0
        JE      IMP_08
        CMP     AL,0AH
        JE      IMP_01
        CMP     AL,0DH          ;Retorno de carro?
        JE      IMP_02          ;Si: calcular y limpiar el resto de la lnea
        CMP     AL,'$'          ;Final de cadena?
        JE      IMP_03          ;Si: salir de la rutina.
        CMP     AL,9
        JE      IMP_09
        MOV     AH,09H          ; No: imprimir
        MOV     CX,0001H        ;un caracter.
        INT     10H
        INC     DL              ; Mover el cursor un columna.
        INC     BP              ; Incrementa contador.
        JMP     IMP_01          ; Obtener siguiente caracter.
IMP_08: MOV     CX,004FH
        SUB     CX,BP
IMP_080:
        PUSH    CX
        MOV     CX,0001H        ;Limpiar un espacio
        MOV     AH,09H
        MOV     AL,20H
        INT     10H
        INC     DL              ;Siguiente espacio
        INC     BP
        MOV     AH,02H          ; Avanza el cursor una columna.
        INT     10H
        POP     CX
        LOOP    IMP_080         ; Limpia siguiente espacio hasta que CX=00
        JMP     IMP_01

IMP_09: MOV     CX,0008H
IMP_090:
        PUSH    CX
        MOV     CX,0001H
        MOV     AL,20H
        MOV     AH,09H
        INT     10H
        INC     DL
        INC     BP
        MOV     AH,02H
        INT     10H
        POP     CX
        LOOP    IMP_090
        JMP     IMP_01
IMP_02: CMP     BP,80
        JE      IMP_21
        MOV     CX,0050H        ; Obtiene No. de columnas
        SUB     CX,BP           ;a limpiar.
IMP_04: PUSH    CX              ; Salva el No. de espacios a limpiar.
        MOV     AL,20H          ; Limpia un espacio de la lnea.
        MOV     AH,09H
        MOV     CX,0001H
        INT     10H
        INC     DL
        INC     BP
        MOV     AH,02H          ; Avanza el cursor una columna.
        INT     10H
        POP     CX
        LOOP    IMP_04          ; Limpia siguiente espacio hasta que CX=00
IMP_21: INC     DH
        MOV     DL,00
        XOR     BP,BP
        JMP     IMP_01
IMP_03:
        ENDM

PrintzStr macro x,y
	mov ah,3
	xor bh,bh
	int 10h
	xor ax,ax
	xor cx,cx
	dec cx
	lea di,x
	repne scasb
	neg cx
	dec cx
	mov bl,y
	lea bp,x
	mov ax,1301h
	int 10h
	endm

; -----------------------------------------------------------------------

sprint          macro x
                mov ah,9
                ifnb <x>
                lea dx,x
                endif
                int 21h
                endm


; =========================================================================
; MACROS PARA EL MANEJO DE ARCHIVOS - For files management
; =========================================================================
; Crear archivo - Create file
create_file     macro x
                local a00
                lea     dx,x
                mov     ax,3C00h
                xor     cx,cx
                int     21h
                jnc     a00
                xor     ax,ax
           a00: nop
                endm

; --------------------------------------------------------------------------
; Abre un archivo - Open file
open_file       macro x,y
                local a07,a08
                lea     dx,x
                mov     al,y
                mov     ah,3Dh        ; Funcion 3Dh: abre archivo
                int     21h
                jc      a07
                jmp     a08
           a07: xor     ax,ax
           a08: nop
                endm

; -------------------------------------------------------------------------
; Leer un archivo - Read file
read_file       macro x,y,z
                local a01
                mov     bx,[x]
                lea     dx,y
                mov     cx,z
                mov     ah,3fh
                int     21h
                jnc     a01
                xor     ax,ax
           a01: nop
                endm

; --------------------------------------------------------------------------
; Lee un caracter - Read a character
read_char       macro x,y
                local a02,a40
                lea     dx,y
                mov     bx,[x]
                mov     ah,3fh                  ; funcion 3Fh: lee el archivo
                mov     cx,1                    ; Leer 1 byte
                int     21h
                jnc     a02
                mov     ax,-1
                jmp     a40
           a02: cmp     ax,0
                je      a40
                mov     si,dx
                lodsb
           a40:
                endm

; -------------------------------------------------------------------------
; Escribe en un archivo - write in a file
write_file      macro x,y,z
                local a05, a06
                mov     bx,[x]
                lea     dx,y
                mov     cx,z
                mov     ah,40h           ; funcion 40h: escribe en el archivo
                int     21h
                jb      a05
                jmp     a06
a05:            xor     ax,ax
a06:            nop
                endm

; -------------------------------------------------------------------------
; Copiar el contenido de un archivo a otro - Copy a file to other
copy_file       macro w,x,y,z
                local a10,a11,a12,a13,a14
           a12: mov     si,[w]   ; fuente
                mov     di,[x]   ; destino
                ; Copiar en un buffer el contenido fuente
           a14: mov     ah,3fh
                mov     bx,si
                mov     cx,z
                lea     dx,y   ; buffer
                int     21h
                jnc     a10
                xor     ax,ax
                jmp     a13
                ; Copiar en el destino el contenido del buffer
           a10: cmp     ax,0
                je      a11
                push    ax
                mov     ah,40h
                mov     bx,di
                pop     cx
                int     21h
                jnc     a12
                xor     ax,ax
                jmp     a14
           a11: mov     bx,di
                close_file bx
           a13: nop
                endm

; -------------------------------------------------------------------------
; Obtener la posicin del puntero - Get the pointer position
GetPointerPos   macro x
                mov bx,[x]
                pos_zero
                SetPointerPos bx,0,0
                endm

; -------------------------------------------------------------------------
; Poner el puntero en un sitio - Set the pointer in a adress
SetPointerPos   macro   x,y,z
                mov     cx,z
                mov     dx,y
                mov     bx,x
                mov     ax,4201h
                int     21h
                endm

; --------------------------------------------------------------------------
; Obtener el tamao del archivo - Get the fuile size
GetFileSize     macro x
                mov bx,[x]    
                mov     ax,4202h
                pos_zero
                int     21h
                endm
                
; ----------------------------------------------------------------------
; Poner el cursor al inicio del archivo - Set the pointer at the file init
SetPointerInitFile macro x
                pos_zero
                SetPointerFromIni x,0,0
                endm

; -----------------------------------------------------------------------
; Poner el puntero en un desplazamiento desde el inicio del archivo
; Set the pointer in a offset from the init file.
SetPointerFromIni macro x,y,z
                mov     bx,[x]
                mov     cx,z
                mov     dx,y
                mov     ax,4200h
                int     21h
                endm

; -----------------------------------------------------------------------

pos_zero        macro
                xor     cx,cx
                xor     dx,dx
                endm

; -----------------------------------------------------------------------
; Cerrar un archivo - Close a file
close_file      macro x
                mov     bx,x
                mov     ah,3Eh
                int     21h
                endm

; ========================================================================
; MACROS PARA TRATAR CADENAS
; ========================================================================

append_char     macro  x, y
                mov     bl,x
                mov     di,y
                xor     ax,ax          ;  Busca 0 en la cadena
                xor     cx,cx          ; apuntada por di
                dec     cx
                repne scasb
                dec     di
                mov     al,bl           ; Coloca el caracter
                stosb
                mov     byte ptr [di],0  ; Agrega cero
                endm

; ------------------------------------------------------------------------

append_str      macro x,y
                mov si,x
                mov di,y
                xor     ax,ax
                xor     cx,cx          ;  Busca 0 en la cadena
                dec     cx             ; apuntada por di
                repne scasb
                not     cx
                dec     di
                push    di             ; di apunta al final de la cadena
                str_leng si 
                mov     cx,ax
                pop     di
                rep movsb             ; Mueve apendice
                endm

; --------------------------------------------------------------------------

str_leng        macro x
                lea di,x
                xor     ax,ax
                xor     cx,cx
                dec     cx
                repne scasb          ; Cuenta cars en cadena apuntada por di
                not     cx
                dec     cl
                mov     ax,cx        ; Devuelve el no. en ax.
                endm

; ==========================================================================
